searchNodes=[{"doc":"Veli is a simple validation library for elixir. Rules Simple Rules When you validate simple types (like a string or an integer), you must use simple rules. Which is a keyword list. rule = [ type : { :string , false } , run : fn value -&gt; String . reverse ( value ) === value end ] Veli . valid ( &quot;wow&quot; , rule ) |&gt; Veli . error ( ) === nil List Rules When you need to validate every item on a list, you must use Veli.Types.List struct so validator can know if it is validating a string or a value. rule = % Veli.Types.List { rule : [ type : { :integer , false } ] } Veli . valid ( [ 4 , 2 , 7 , 1 ] , rule ) |&gt; Veli . error ( ) === nil Map Rules When you need to validate a map (an object), you must use Veli.Types.Map struct so validator can know if it is validating a map or a value. rule = % Veli.Types.Map { rule : %{ username : [ type : { :string , false } ] , age : [ type : { :integer , false } , min : 13 ] } } Veli . valid ( %{ username : &quot;bob&quot; , age : 16 } , rule ) |&gt; Veli . error ( ) === nil Custom Errors By default, Any error returns false . You can specify custom errors with adding underscore (_) prefix. rule = [ type : { :integer , false } , _type : &quot;Value must be an integer!&quot; ] Veli . valid ( 10 , rule ) |&gt; Veli . error ( ) # nil Veli . valid ( &quot;invalid value&quot; , rule ) |&gt; Veli . error ( ) # &quot;Value must be an integer!&quot; Custom Errors for Map or List As you can see in Veli.Types.Map or Veli.Types.List , they both have a field named &quot;error&quot; which is nil by default. You can specify custom errors with &quot;error&quot; field. rule = % Veli.Types.Map { rule : %{ username : [ type : { :string , false } ] , age : [ type : { :string , false } , min : 13 ] } , error : &quot;Not a valid object.&quot; } Veli . valid ( %{ username : &quot;bob&quot; , age : 16 } , rule ) |&gt; Veli . error ( ) # nil Veli . valid ( 96 , rule ) |&gt; Veli . error ( ) # &quot;Not a valid object.&quot; More Example You can read library tests for more example.","ref":"Veli.html","title":"Veli","type":"module"},{"doc":"Returns first error from validate result. Returns nil if everything is valid. Example rule = % Veli.Types.List { rules : [ type : { :float , true } ] } Veli . valid ( [ 5 , 3.2 , &quot;how&quot; ] , rule ) |&gt; Veli . error ( )","ref":"Veli.html#error/1","title":"Veli.error/1","type":"function"},{"doc":"Returns all false validates. Example rule = % Veli.Types.List { rules : [ type : { :float , true } ] } Veli . valid ( [ 5 , 3.2 , &quot;how&quot; ] , rule ) |&gt; Veli . errors ( )","ref":"Veli.html#errors/1","title":"Veli.errors/1","type":"function"},{"doc":"Validate a value with rules. Returns a keyword list which contains results. You should not process that result yourself. Use Veli.errors or Veli.error for processing results instead. Example rule = [ type : { :string , false } , match : ~r/^https?/ ] Veli . valid ( &quot;wow&quot; , rule ) |&gt; Veli . error ( ) !== nil Veli . valid ( &quot;https://hex.pm&quot; , rule ) |&gt; Veli . error ( ) === nil More examples can be found in library tests.","ref":"Veli.html#valid/2","title":"Veli.valid/2","type":"function"},{"doc":"Custom struct for validator list lookup. Example rule = % Veli.Types.List { rule : [ type : :integer , _type : &quot;List member must be an integer&quot; ] , error : &quot;Value must be a list&quot; }","ref":"Veli.Types.List.html","title":"Veli.Types.List","type":"module"},{"doc":"Custom struct for validator map lookup. Example rule = % Veli.Types.Map { rule : %{ username : [ type : :string , min : 3 , max : 32 ] , password : [ type : :string , min : 8 , max : 72 ] , accepted : [ type : :boolean , match : true ] } , error : &quot;Value must be a map&quot; }","ref":"Veli.Types.Map.html","title":"Veli.Types.Map","type":"module"},{"doc":"Inside validator. Example rule = [ type : :string , inside : [ &quot;value1&quot; , &quot;value2&quot; ] ] Veli . valid ( &quot;value1&quot; , rule )","ref":"Veli.Validators.Inside.html","title":"Veli.Validators.Inside","type":"module"},{"doc":"","ref":"Veli.Validators.Inside.html#valid?/2","title":"Veli.Validators.Inside.valid?/2","type":"function"},{"doc":"Match validator. Uses regex if match value is a regex sigil. Otherwise compares both values. Example rule = [ type : :string , match : ~r/^https?/ ] Veli . valid ( &quot;https://example.com&quot; , rule )","ref":"Veli.Validators.Match.html","title":"Veli.Validators.Match","type":"module"},{"doc":"","ref":"Veli.Validators.Match.html#valid?/2","title":"Veli.Validators.Match.valid?/2","type":"function"},{"doc":"Max validator. Example rule = [ max : 20 ] Veli . valid ( &quot;valid length&quot; , rule ) Veli . valid ( 30 , rule ) # invalid","ref":"Veli.Validators.Max.html","title":"Veli.Validators.Max","type":"module"},{"doc":"","ref":"Veli.Validators.Max.html#valid?/2","title":"Veli.Validators.Max.valid?/2","type":"function"},{"doc":"Min validator. Example rule = [ min : 5 ] Veli . valid ( &quot;valid length&quot; , rule ) Veli . valid ( 1 , rule ) # invalid","ref":"Veli.Validators.Min.html","title":"Veli.Validators.Min","type":"module"},{"doc":"","ref":"Veli.Validators.Min.html#valid?/2","title":"Veli.Validators.Min.valid?/2","type":"function"},{"doc":"Outside validator. Example rule = [ type : :integer , outside : [ 0 , 2 , 4 , 8 ] ] Veli . valid ( 12 , rule ) # valid Veli . valid ( 0 , rule ) # not valid","ref":"Veli.Validators.Outside.html","title":"Veli.Validators.Outside","type":"module"},{"doc":"","ref":"Veli.Validators.Outside.html#valid?/2","title":"Veli.Validators.Outside.valid?/2","type":"function"},{"doc":"Allows you to add custom validator. Any other value than true will computed as false . Example rule = [ type : :integer , run : fn x -&gt; rem ( x , 2 ) === 0 end ] Veli . valid ( 2 , rule ) # valid Veli . valid ( 3 , rule ) # not valid","ref":"Veli.Validators.Run.html","title":"Veli.Validators.Run","type":"module"},{"doc":"","ref":"Veli.Validators.Run.html#valid?/2","title":"Veli.Validators.Run.valid?/2","type":"function"},{"doc":"Type validator. Takes a tuple that contains a atom with nullable boolean. Atoms :string :integer :float :boolean Example rule = [ type : { :integer , true } ] Veli . valid ( 2 , rule ) # valid Veli . valid ( nil , rule ) # valid Veli . valid ( 4.2 , rule ) # not valid","ref":"Veli.Validators.Type.html","title":"Veli.Validators.Type","type":"module"},{"doc":"","ref":"Veli.Validators.Type.html#valid?/2","title":"Veli.Validators.Type.valid?/2","type":"function"}]